#ifndef TPCElectronicsProcessor_h
#define TPCElectronicsProcessor_h 1


#include "marlin/Processor.h"
#include "lcio.h"
#include <IMPL/LCCollectionVec.h>
#include <string>
//#include <gsl/gsl_rng.h>
//#include <gsl/gsl_randist.h>

/** Processor to apply electronic effect like shaping and binning of chareg into ADCCounts.
 */
class TPCElectronicsProcessor : public marlin::Processor {
  
 public:
  
  virtual Processor*  newProcessor() { return new TPCElectronicsProcessor ; }
  
  TPCElectronicsProcessor() ;
  virtual ~TPCElectronicsProcessor(){}  
  /** Called at the begin of the job before anything is read.
   * Use to initialize the processor, e.g. book histograms.
   */
  virtual void init() ;
  
  /** Called for every run.
   */
  virtual void processRunHeader( lcio::LCRunHeader* run ) ;
  
  /** Called for every event - the working horse.
   */
  virtual void processEvent( lcio::LCEvent * evt ) ; 
  
  
  virtual void check( lcio::LCEvent * evt ) ; 
  void WritePeak(double ,int ,int ,
		 int, lcio::LCCollectionVec*, double);
  
  /** Called after data processing for clean up.
   */
  virtual void end() ;

protected:
  int _nRun ;
  int _nEvt ;
  double slicewidth;  //in ns
  int adcbins;
  int timejump;
  int timeslices;
  int is_transient;
  double adcchargefactor;
  float frequency;
  std::string tpcpads;
  std::string driftelectrons;
  std::string primaries;
  std::string _outputCollectionName;
  float risetime;
  int adcres;
  int adcmaxcharge;
  int adcthreshold;
  double gainfactor;
  double cutoff;
};

#endif 
