#ifndef TRACK_FITTER_CHI_SQUARE_H
#define TRACK_FITTER_CHI_SQUARE_H

#include "TrackFitterBase.h"

namespace marlintpc
{

    /** g\f$\chi^2\f$ implementation of a track fitter.\n
     *  Currently the actual fitter is not implemented yet.
     *  But one can instanciate the fitter to use the
     *  getResiduals functions derrived from TrackFitterBase.
     *
     *  \todo: Implement the fitter function.
     */

class TrackFitterChiSquare : public TrackFitterBase
{
    public:
    /// Constructor, empty for the simple g\f$\chi^2\f$ fitter
	TrackFitterChiSquare();

	/// returns the revision of this implementation and of the TrackFitterBase it is derrived from
	virtual std::string getRevision();

	/// The actual fitter. Not implemented yet, thows gear::NotImplementedException
	virtual IMPL::TrackImpl *fitTrack(EVENT::Track *seedTrack);

	/// returns FitterTypes::CHISQUARE
	virtual int getFitterType();
};

} // namespace marlintpc

#endif // TRACK_FITTER_CHI_SQUARE_H
