#include "PedestalHandler.h"

namespace marlintpc{

//#ifdef USE_LCCD
PedestalHandler::PedestalHandler (std::string ColName )
{
    if ( ! (marlin::ConditionsProcessor::registerChangeListener( this, ColName ) ) ){
	std::cerr<<"ERROR: PedestalHandler cannot register collection "
		 <<ColName<<" in ConditionsProcessor"<<std::endl;
	throw DataNotAvailableException("PedestalHandler: cannot register pedestal collection");
	
    };
	
}
//#else
//    PedestalHandler::PedestalHandler( std::string pedestalColName, std::string pedestalFileName ){
//	LCReader* Reader = LCFactory::getInstance()->createLCReader();
//	try{
//	    Reader->open( pedestalFileName );
//	    LCEvent* pedestalEvt = Reader->readNextEvent();
//	    if (pedestalEvt){
//		try{
//		    LCCollection* pedestalCol = pedestalEvt->getCollection( pedestalColName ) ;
//		    conditionsChanged( pedestalCol );
//		}catch(DataNotAvailableException &e){
//		    // if there is not input collection give a warning to the user
//		    std::cerr<<"ERROR of PedestalHandler: pedestal collection "
//			     <<pedestalColName<<" cannot be found."<<std::endl;	
//		    throw e;
//		}
//	    }
//	    delete pedestalEvt;
//	    Reader->close();
//	}catch(IOException& e){
//	    std::cerr<< "ERROR of PedestalHandler: io error when reading LCIO data : " 
//		     << e.what() << std::endl ;
//	    throw e;
//	}
//	delete Reader;
//    }
//#endif
    
    
PedestalHandler::~PedestalHandler()
{
    
}
    
void PedestalHandler::conditionsChanged( EVENT::LCCollection* col )
{
    
    tpcconddata::Pedestal* Entry = 0;
	
    int nEntries = col->getNumberOfElements();
    
    std::cout<<"PedestalHandler: update pedestals  ("<<nEntries<<" in collection)"<<std::endl;
    
	for (int iEntry = 0; iEntry < nEntries; iEntry++){
	    
	    Entry = new tpcconddata::Pedestal( dynamic_cast<LCGenericObject*>
					       ( col->getElementAt( iEntry ) ) );
	    
	    // fill the Pedestal in the map, create a new entry if neccesary
	    _PedestalMap[Entry->getChannel()] = Entry;
	    
	    //Entry->print( std::cout );
	    
	}
}
    
    tpcconddata::Pedestal* PedestalHandler::getPedestal( int Channel ){

	PedestalMap::iterator returnPedestal = _PedestalMap.find( Channel );
	
	if( returnPedestal == _PedestalMap.end() ){
	    // return null pinter if no pedestal for the channel ID can be found
	    return 0;
	}
	else{
	    return returnPedestal->second;
	}

    }

    float PedestalHandler::getPedestalValue( int Channel ){

	tpcconddata::Pedestal* Entry = getPedestal( Channel );

	if (Entry == 0 ){
	    return 0;
	}
	else{
	    return Entry->getPedestalValue();
	}
	
    }

    float PedestalHandler::getPedestalWidth( int Channel ){

	tpcconddata::Pedestal* Entry = getPedestal( Channel );

	if (Entry == 0 ){
	    return -1;
	}
	else{
	    return Entry->getPedestalWidth();
	}
	
    }
    
}    
