#ifndef HEPREPOUTPUTPROCESSOR_H
#define HEPREPOUTPUTPROCESSOR_H 1

#include "marlin/Processor.h"
#include "lcio.h"
#include <string>

using namespace lcio ;
using namespace marlin ;


/** HepRepOutputProcessor: This early version processor displays the event using MarlinED
 *    @author J. Abernathy (UVic)<br>
 */
class HepRepOutputProcessor : public Processor {
  
public:

	/** Default constructor
	*/
	HepRepOutputProcessor();


	/** Destructor
	*/
	~HepRepOutputProcessor();


	/** Return a new instance of this processor
	*/
	Processor * newProcessor();


	/** Called at the begin of the job before anything is read.
	*/
	void init();


	/** Called once per run to process the event's header
	*/
	void processRunHeader (LCRunHeader *run);


	/** Called for every event - the working horse.
	*/
	virtual void processEvent(LCEvent *evt);


	/** Called for every event - right after processEvent() has been called for all processors.
	*/
	virtual void check (LCEvent *evt);


	/** Called after data processing for clean up in the inverse order of the init() method so that resources allocated in the first processor also will be available for all following processors.
	*/
	virtual void end();

private:

	std::vector<std::string> _simtrackerhit_collection_names;
	std::vector<std::string> _trackerdata_collection_names;
	std::vector<std::string> _trackerhit_collection_names;
	std::string _trackerpulse_collection_names;
	std::string _track_collection_names;
	
	// the HepRepXML writer
	HepRepXMLWriter _heprep_writer;
	
	/** The event numbers to display **/
	std::vector<int> _events_to_display;
};

#endif // HEPREPOUTPUTPROCESSOR_H



