#ifndef ADCChannelMapping_h
#define ADCChannelMapping_h 1

//C++
#include "iostream"
#include "string"

//LCIO
#include "lcio.h"
#include "UTIL/LCFixedObject.h"

#define ADCChannelMappingNINTVals 3 
#define ADCChannelMappingNFLOATVals 0
#define ADCChannelMappingNDOUBLEVals 0

namespace tpcconddata{

class ADCChannelMapping;

/** class to store the mapping pad (position) to the channel ID (electronic)
 *  also the type of trhe used electronic can be stored
 */
class ADCChannelMapping : public UTIL::LCFixedObject<ADCChannelMappingNINTVals,
			  ADCChannelMappingNFLOATVals,ADCChannelMappingNDOUBLEVals> {

public:

    ADCChannelMapping(int ChannelID, int PadID, int Type = -1);

    ADCChannelMapping(EVENT::LCObject* obj) : UTIL::LCFixedObject<ADCChannelMappingNINTVals,
								  ADCChannelMappingNFLOATVals,
								  ADCChannelMappingNDOUBLEVals>(obj) { } 
    
    virtual ~ADCChannelMapping();

    int getChannelID();
    int getPadID();
    int getType();

    static std::string getRevision();
    static std::string getDefaultColName();

    void print ( std::ostream& os = std::cout );
    std::ostream& operator<<( std::ostream& os );

    // -------- need to implement abstract methods from LCGenericObject
    virtual const std::string getTypeName() const{
	return std::string("ADCChannelMapping");
    }
    
    virtual const std::string getDataDescription() const{
	return std::string("i:ChannelIDs,PadID,Type");	
    }

protected:

    void setChannelID(int Channel);
    void setPadID(int Pad);
    void setType(int Type);
};

}

#endif
