/* ADCChannelMapping.cc
 * $Id$ 
 */

#include "ADCChannelMapping.h"

namespace tpcconddata{

std::string ADCChannelMapping::getRevision(){
    return std::string("$Rev: 237 $");
}

std::string ADCChannelMapping::getDefaultColName(){
    return std::string("TPCADCChannelMapping");
}

ADCChannelMapping::ADCChannelMapping(int ChannelID, int PadID, int Type ){
    setChannelID(ChannelID);
    setPadID(PadID);
    setType(Type);
}

ADCChannelMapping::~ADCChannelMapping(){ }

int ADCChannelMapping::getChannelID(){
    return obj()->getIntVal( 0 ) ;
}

int ADCChannelMapping::getPadID(){
    return obj()->getIntVal( 1 ) ;
}

int ADCChannelMapping::getType(){
    return obj()->getIntVal( 2 ) ;
}

void ADCChannelMapping::print ( std::ostream& os ){
    os<<"ADCChannelMapping: Pad  "<<getPadID()
      <<" <-> "
      <<"Channel "<<getChannelID()
      <<" (Type: "<<getType()<<")"
      <<std::endl;
} 

std::ostream& ADCChannelMapping::operator<<( std::ostream& os ){
    
    print(os);
    return os;
}

void ADCChannelMapping::setChannelID(int Channel){
    obj()->setIntVal( 0, Channel) ;
}

void ADCChannelMapping::setPadID(int Pad){
    obj()->setIntVal( 1, Pad) ;
}

void ADCChannelMapping::setType(int Type){
    obj()->setIntVal( 2, Type) ;
}

}
