/* Pedestal.cc
 * $Id$ 
 */

#include "Pedestal.h"

namespace tpcconddata{

std::string Pedestal::getRevision(){
    return std::string("$Rev: 237 $");
}

std::string Pedestal::getDefaultColName(){
    return std::string("TPCPedestal");
}

Pedestal::Pedestal(int channel, float PedestalValue, float PedestalWidth) {
    setChannel(channel);
    setPedestalValue(PedestalValue);
    setPedestalWidth(PedestalWidth);
}

Pedestal::Pedestal(int channel) {
    setChannel(channel);
    setPedestalValue(0);
    setPedestalWidth(0);
}

Pedestal::~Pedestal() { /* no op*/  }
  
int Pedestal::getChannel() {
    return obj()->getIntVal( 0 ) ; 
} 

float Pedestal::getPedestalValue() {
    return obj()->getFloatVal( 0 ) ;
} 

float Pedestal::getPedestalWidth() {
    return obj()->getFloatVal( 1 ) ;
} 

void Pedestal::setPedestalValue(float PedestalValue) {
    obj()->setFloatVal( 0 , PedestalValue ) ;
}

void Pedestal::setPedestalWidth(float PedestalWidth) {
    obj()->setFloatVal( 1 , PedestalWidth ) ;
}

void Pedestal::setChannel(int channel) { 
    obj()->setIntVal( 0 , channel ) ;
}

void Pedestal::print(  std::ostream& os ){
    std::streamsize PrecisionBefore = os.precision();
    std::streamsize WidthBefore = os.width();
    os.precision(3);  os.setf(std::ios_base::fixed);
    os << "Pedestal: Channel: " << getChannel() << std::fixed; 
    os << " PedestalValue: " << getPedestalValue() << " PedestalWidth: " << getPedestalWidth() << std::endl;
    os.unsetf( std::ios_base::fixed );
    os.precision( PrecisionBefore );
    os.width( WidthBefore );
}
  
std::ostream& Pedestal::operator<<( std::ostream& os ){
    print( os );
    return os;   
}

}
