/* WeatherConditions.cc
 * $Id$ 
 */

#include "WeatherConditions.h"

namespace tpcconddata{

std::string WeatherConditions::getRevision(){
    return std::string("$Rev: 509 $");
}

std::string WeatherConditions::getDefaultColName(){
    return std::string("TPCWeatherConditions");
}

WeatherConditions::WeatherConditions(){
    setTemperatur( 0 );
    setPressure( 0 );
    setRelHumidity( 0 );
}

WeatherConditions::~WeatherConditions(){ ; }

float WeatherConditions::getTemperatur(){
    return obj()->getFloatVal( 0 );
}

float WeatherConditions::getPressure(){
    return obj()->getFloatVal( 1 );
}

float WeatherConditions::getRelHumidity(){
    return obj()->getFloatVal( 2 );
}

void WeatherConditions::setTemperatur( float Value ){
    obj()->setFloatVal( 0, Value);
}

void WeatherConditions::setPressure( float Value ){
    obj()->setFloatVal( 1, Value);
}

void WeatherConditions::setRelHumidity( float Value ){
    obj()->setFloatVal( 2, Value);
}

void WeatherConditions::print( std::ostream& os ){

    os<<"temperatur:    "<<getTemperatur()<<" C"<<std::endl;
    os<<"pressure:      "<<getPressure()<<" hPa"<<std::endl;
    os<<"rel. humidity: "<<getRelHumidity()<<" %"<<std::endl;

}

std::ostream& WeatherConditions::operator<<( std::ostream& os ){
    print( os );
    return os;
}

}

