#include "marlin/Processor.h"
#include "lcio.h"

using namespace lcio ;

class TH1F;
class TH2F;
class TFile;
class MyRecoDisplay;

class PandoraPFAEventDisplay : public marlin::Processor {
  
 public:
  
 virtual marlin::Processor*  newProcessor() { return new PandoraPFAEventDisplay ; }
  
  PandoraPFAEventDisplay() ;

  /** Called at the begin of the job before anything is read.
   * Use to initialize the processor, e.g. book histograms.
   */
  virtual void init() ;

  /** Called for every run.
   */
  virtual void processRunHeader( LCRunHeader* run ) ;

  /** Called for every event - the working horse.
   */
  virtual void processEvent( LCEvent * evt ) ; 


  /** Called after data processing for clean up.
   */
  virtual void end() ;

  void JetsAtDetector( LCEvent* evt );

  void DrawPFOs( LCEvent* evt );

private:
  
protected:
  int _nRun ;
  int _nEvt ;
  int _display;
  MyRecoDisplay* _recoDisplay;
  std::string _pfoCollectionName;
  std::string _jetCollectionName;
  int _drawUnused;
  int _drawJets;
  int _drawPFOs;
  int _drawXY;
  int _drawXZ;
  int _drawRZ;
  float _plotRange;
} ;

