#ifndef SiTrkClusteringProcessor_h
#define SiTrkClusteringProcessor_h 1

//#define _DEBUG_CLUST_

#include <iostream>
#include <string>
#include <vector>

#include "marlin/Processor.h"

#include "lcio.h"
#include "EVENT/LCCollection.h"

#include "IMPL/LCCollectionVec.h"
#include "IMPL/TrackerRawDataImpl.h"
#include "IMPL/TrackerHitImpl.h"
#include "IMPL/LCRelationImpl.h"

#include "UTIL/CellIDDecoder.h"

#include "SiTracker.h"

using namespace std ;
using namespace lcio ;
using namespace marlin ;

/**  Marlin event processor to find Tracker Hits by using
 *   digi-collections of Silicon barrel and disk layer
 *    
 * 
 * @author S.Shulga
 * @version $Id: SiTrkClusteringProcessor.h,v 1.2 2007-11-07 10:52:36 shulga Exp $ 
 */

namespace SICLUPROC{


class SiTrkClusteringProcessor : public Processor {
  
 public:
  
  virtual Processor*  newProcessor() { return new SiTrkClusteringProcessor ; }
  
  
  // constructor
  SiTrkClusteringProcessor() ;
  
  /** Use to initialize the processor
   */
  virtual void init() ;

  /** Called for every run
   */
  virtual void processRunHeader( LCRunHeader* run ) ;
  
  /** Called for every event - the working horse
   */
  virtual void processEvent( LCEvent * evt ) ; 

  /** Called by processEvent
   */
  void createOutputCollections_pixels
      ( LCCollection           * inColl,
        LCCollection           * inRelColl,
	vector<LCCollection*>  & outCollVec ) throw( string ) ;

  /** Called for every event
   */
  virtual void check( LCEvent * evt ) ; 
  
  /** Called after data processing for clean up.
   */
  virtual void end() ;
    
 protected:

  /** Parameters from steering file.
   */
  string _inputColName, _inputColName_second, 
  	 _inputRelColName, _outputColName, _outputRelColName ;

  int _printRunHeaderInform ; 

//  IntVec _iLayers ;

  StringVec  _subDet_Technology ;

  SIDET::SiTracker *_detector ;

  int _nRun ;
  int _nEvt ;
  
  string _stechnology ;

} ;

} // namespace SITRK{.

#endif
