#include "SiTrkClusteringProcessor.h"

namespace SICLUPROC{

/** prepare  collections to be appended to LCEvent:
 */
void SiTrkClusteringProcessor::createOutputCollections_pixels
                      ( LCCollection           * inColl,
		        LCCollection           * inRelColl,
		        vector<LCCollection*>  & outCollVec ) 
			 throw( string ) {

 string CC = "SiTrkClusteringProcessor::createOutputCollections_pixels:" ;

/** Create collection for writing raw hits into LCIO file
 */

 int NHits = inColl->getNumberOfElements();

 // Loop over raw hits :
 for( int i = 0; i < NHits; ++i ) {

   TrackerRawDataImpl* rawhit
     = dynamic_cast< TrackerRawDataImpl* >( inColl->getElementAt( i ) );

#ifdef _DEBUG_CLUST_
cout << CC << endl <<" rawhit->getCellID0(), rawhit->getCellID1() = "<< rawhit->getCellID0()<<", "<<rawhit->getCellID1()<<" time="<<rawhit->getTime() << endl;
#endif
   _detector->fillDetUnits( rawhit ) ;  

 } // for( int i = 0; i < NHits.

 cout << "Final: " << CC << endl 
     <<" Total accepted raw hits "<< _detector->getTotalAcceptedRawHits()
     << endl ;

 _detector->howManyRawHits() ;

 /** return collections
  */
  
 _detector->clusterizeDetUnits( outCollVec ) ;


#ifdef _DEBUG_CLUST_
cout << "<<end>> debug in " + CC << endl ;
#endif

} //  SiTrkClusteringProcessor::createOutputCollections_pixels.

} //namespace SITRK.
