#ifndef PixelReco_Cluster_Parameter_Estimator_H
#define PixelReco_Cluster_Parameter_Estimator_H

#include "DetGeometry/GeomVector/LocalPoint.h"
#include "DetGeometry/LocalError.h"
#include "Cluster.h"

/** CMS software, ORCA. Class ClusterParameterEstimator
 *  Abstract class for the estimation of cluster parameters.
 *  Concrete classes are CPEFromDetPosition and CPEFromTrackAngles
 *
 *  Adapted in MarlinReco : S Shulga 2007/06/06
 *  @version $Id: CPEFromDetPosition.h, v 1 2007/06/06 shulga
 */
namespace SICLU {

class ClusterParameterEstimator {

public:

  virtual ~ClusterParameterEstimator(){}
  virtual SIUTIL::LocalError localError( const Cluster&) const = 0;


  virtual SIUTIL::LocalPoint localPosition( const Cluster&) const = 0;

};

} // namespace SICLU.

#endif
