#ifndef PixelReco_ClusterParameterEstimatorFactory_H
#define PixelReco_ClusterParameterEstimatorFactory_H

#include "Pixel/SiRectangularDetUnit.h"
#include "PixelErrorParametrization.h"

/** CMS software, ORCA. Class ClusterParameterEstimator
 *  A factory to choose the estimator for the position and error of
 *  pixel hits. One uses the DetUnit only and the other also 
 *  the TrajectoryStateOnSurface.
 *
 *  Adapted in MarlinReco : S Shulga 2007/06/06
 *  @version $Id: ClusterParameterEstimatorFactory.h, v 1 2007/06/06 shulga
 */

namespace SICLU {

  class ClusterParameterEstimator;

class ClusterParameterEstimatorFactory {
public:

  ~ClusterParameterEstimatorFactory();

  ClusterParameterEstimator* get( const SIDETUNIT::DetUnit& det) const throw(string) ;

private:

  static PixelErrorParametrization* theErrorMatrix;

};

}

#endif
