#ifndef EtaCorrection_H
#define EtaCorrection_H


/** CMS software, ORCA.
 *   Define 'eta'-corrections for the pixel hit position determination 
 *   depending on the charge ratio qFirst/(qFirst-qLast) 
 *
 *  Adapted in MarlinReco : S Shulga 2007/06/06
 *  @version $Id: EtaCorrection.h, v 1 2007/06/06 shulga
 */

namespace SICLU{

class EtaCorrection{

public:

  EtaCorrection(){};
  ~EtaCorrection(){};

  float xEtaShift(const int& size, const float& pitch, 
		  const float& charatio, const float& alpha) const;
  float yEtaShift(const int& size, const float& pitch, 
		  const float& charatio, const float& beta) const;

private:
};


} // namespace SICLU.

#endif
