#ifndef PixelClusterizer_H
#define PixelClusterizer_H

#include "Pixel/SiRectangularDetUnit.h"
#include "IMPL/TrackerHitImpl.h"

#include "UTIL/CellIDDecoder.h"

#include <vector>

using namespace IMPL ;

/** CMS software, ORCA.
 *  Abstract interface for Pixel Clusterizers
 *
 *  Adapted in MarlinReco : S Shulga 2007/06/06
 *  @version $Id: PixelClusterizer.h, v 1 2007/06/06 shulga
 */

namespace SICLU{

class PixelClusterizer {

public:

  virtual ~PixelClusterizer() {}
    
  // Default clusterization
  virtual void  clusterize( SIDETUNIT::DetUnit * r ) = 0;

}; // class PixelClusterizer.


} // namespace SICLU.

#endif
