#ifndef PixelReco_PixelPos_H
#define PixelReco_PixelPos_H

#include "Shift.h"

/** CMS software, ORCA.
 *  Position of a pixel hit : row() and col()
 *
 *  Adapted in MarlinReco : S Shulga 2007/06/06
 *  @version $Id: PixelClusterizer.h, v 1 2007/06/06 shulga
 */

namespace SICLU {

class PixelPos {

public:

  PixelPos() : theRow(0), theCol(0) {}
  PixelPos(int row, int col) : theRow(row) , theCol(col) {}

  int row() const { return theRow;}
  int col() const { return theCol;}

  PixelPos operator+( const Shift& shift) {
    return PixelPos( row() + shift.dx(), col() + shift.dy());
  }
    
private:

  int theRow;
  int theCol;

}; // class PixelPos.

} // namespace SICLU.

#endif
