#ifndef _AMPLITUDE_H_
#define _AMPLITUDE_H_

//#define _DEBUG_DU_2_

using namespace std ;

  /**  CMS software, 2007.
   *  @version $Id: Amplitude.h, v 1 2007/06/06 shulga
   */
namespace SIDETUNIT{


/** map to store pixels (int chan) by charge_fraction (double)
 *  (used in SiPixelDetUnitDigitizer::induce_signal 
 *  and DetUnit::set_signal )
 */
typedef map< int, double, less<int> > hit_map_type ;

  /** Definition class.
   */
class Amplitude {

  public:

    Amplitude() : _amp(0.0) { /* _hits.reserve(1) ; */ }

    Amplitude( double amp, SiTrkSimHitExtended* hitp) 
    	: _amp(amp) {  // _hits(1, hitp) {} //	  _hits(hitp) { 
	  _hits.push_back( hitp ) ;
   }

    operator double() const { return _amp; }

    const SiTrkSimHitExtendedVec& hits() { return _hits ; }

    void operator+=( const Amplitude& other) {
      _amp += other._amp;
      _hits.insert( _hits.end(), other._hits.begin(), other._hits.end());
    }

    void operator+=( const double& amp) { _amp += amp; }
   
    void set (const double amplitude) { _amp = amplitude; } // Used to reset the amplitude

  private:

    double _amp;

    SiTrkSimHitExtendedVec _hits;

} ;  // end class Amplitude

typedef map< int, Amplitude, less<int> >   signal_map_type ;

typedef signal_map_type::iterator          signal_map_iterator ;


} //namespace SIDETUNIT{

#endif
