#ifndef _SITRKSIMHIT_H_
#define _SITRKSIMHIT_H_

//#define _DEBUG_STS_

#include "math.h"
#include <string>
#include <sstream>

#include "CLHEP/Vector/ThreeVector.h"
#include "IMPL/SimTrackerHitImpl.h"
#include "IMPL/MCParticleImpl.h"
#include "SiUtil.h"

using namespace std ;
using namespace EVENT ;
using namespace CLHEP ;
using namespace IMPL ;

/**  Class for temporary extended sim. hit
 *
 *   @author S.Shulga
 *   @version $Id: SiTrkSimHitExtended.h, v 1 2007/06/06 shulga
 */

namespace SIDETUNIT{


class SiTrkSimHitExtended : public SimTrackerHitImpl {
 
 public:

  SiTrkSimHitExtended( SimTrackerHitImpl & simHit ) ;

  void setEntryExitPoints( Hep3Vector & hitEntryPoint, 
			   Hep3Vector & hitExitPoint ) ;

  void setHitGlobalPosMom( Hep3Vector & hitGlobalPos,
			   Hep3Vector & hitGlobalMom ) ;

  void setHitLocalPosMom( Hep3Vector & hitLocalPos,
			  Hep3Vector & hitLocalMom ) ;

  Hep3Vector entryPoint() const { return _hitEntryPoint ; } ;
  Hep3Vector exitPoint() const { return _hitExitPoint ; }  ;  // in det.unit frame

  Hep3Vector getHitGlobalPos() const { return _hitGlobalPos ; } ;
  Hep3Vector getHitLocalPos() const { return _hitLocalPos ; } ;

  Hep3Vector getHitGlobalMom() const { return _hitGlobalMom ; } ;
  Hep3Vector getHitLocalMom() const { return _hitLocalMom ; } ;

  double pabs() const { return  _hitGlobalMom.mag() ; } ;

 private:

  Hep3Vector _hitGlobalPos ;  // hit position in detector frame
  Hep3Vector _hitLocalPos ;   // hit positions in det.unit frame

  Hep3Vector _hitGlobalMom ;  // hit momentums in det.unit frame
  Hep3Vector _hitLocalMom ;        // hit momentums in det.unit frame

  Hep3Vector _hitEntryPoint, _hitExitPoint ;  // in det.unit frame

 // time: TOF cut in nanoseconds, default 1 LHC clock, so +-12.5ns.
 // TofCut = 12.5
} ; // SiTrkSimHitExtended.

//-------------------

typedef vector< SiTrkSimHitExtended *> SiTrkSimHitExtendedVec ;



} //namespace SIDETUNIT{

#endif
