#include "Pixel/RectangularPixelTopology.h"

namespace SIDETUNIT{

SIUTIL::LocalError 
RectangularPixelTopology::localError( const SIUTIL::MeasurementPoint& mp,
				      const SIUTIL::MeasurementError& me) const {
  return SIUTIL::LocalError( me.uu()*(m_pitchx*m_pitchx), 0,
		     me.vv()*(m_pitchy*m_pitchy));
}

SIUTIL::MeasurementError 
RectangularPixelTopology::measurementError( const SIUTIL::LocalPoint& lp,
					    const SIUTIL::LocalError& le) const {
  return SIUTIL::MeasurementError( le.xx()/(m_pitchx*m_pitchx), 0,
			   le.yy()/(m_pitchy*m_pitchy));
}

} //namespace SIDETUNIT{
