#include "SiDigitizer.h"


namespace SIDIGIR{

void SiPixelDetUnitDigitizer::reset_sumSimHits() { _sum_sim_Hits = 0 ; }

void SiPixelDetUnitDigitizer::reset_sumInduceSignals() { _sum_induce_signals = 0 ; }

// Constructor. Setup all "constant" parameters.
// If later we decide to use different e.g. pixel threshold for different
// detector type we will have to move some "constants" to digitize(). 

SiPixelDetUnitDigitizer::SiPixelDetUnitDigitizer() {
  // Common pixel parameters
  // This are parameters which are not likely to be changed
  _NumberOfSegments = 20 ;     // Default number of track segment divisions
  _ClusterWidth     = 3. ;     // Charge integration spread on the collection plane
  _GeVperElectron   = 3.7E-09 ;// 1 electrons=3.7eV, 1keV=270.3e

  // ORCA: Sigma0 = 0.0007 cm;  Dist300 = 0.0300 cm; //   normalized to 300micron Silicon
  _Sigma0           = 0.007 ;  // mm,  Charge diffusion constant 
  _Dist300 	    = 0.300 ;  // mm,   normalized to 300micron Silicon

  // Fluctuate charge in track subsegments
  _fluctuateCharge = true ; 

  _isItBarrel = true ;  // Is it barrel or forward

  _sum_sim_Hits = 0 ;
  
  _sum_induce_signals = 0 ;

} // constructor SiPixelDetUnitDigitizer.

/***********************************************************************/
SiPixelDetUnitDigitizer::~SiPixelDetUnitDigitizer() {
#ifdef _DEBUG_1_
  cout << " SiPixelDetUnitDigitizer deleted " <<endl;
#endif
}

} // namespace SIDIGIR.
