#ifndef MeasurementError_H
#define MeasurementError_H

/** CMS software, ORCA.
 *  A very simple class for 2D error matrix components,
 *  used for the measurement frame.
 *
 *  Adapted in MarlinReco : S Shulga 2007/06/06
 *  @version $Id: MeasurementError.h, v 1 2007/06/06 shulga
 */

namespace SIUTIL{

class MeasurementError {
public:

  MeasurementError() : theuu(0), theuv(0), thevv(0) {}

  MeasurementError( double uu, double uv, double vv) :
    theuu(uu), theuv(uv), thevv(vv) {}

  double uu() const { return theuu;}
  double uv() const { return theuv;}
  double vv() const { return thevv;}

private:

  double theuu;
  double theuv;
  double thevv;

};  

} // namespace SIUTIL{.

#endif // MeasurementError_H
