#ifndef MeasurementPoint_H
#define MeasurementPoint_H

#include "DetGeometry/MeasurementTag.h"
#include "DetGeometry/GeomVector/Point2DBase.h"
#include "DetGeometry/GeomVector/Point3DBase.h"

/** CMS software, ORCA.
 *
 *  Adapted in MarlinReco : S Shulga 2007/06/06
 *  @version $Id: MeasurementPoint.h, v 1 2007/06/06 shulga
 */

namespace SIUTIL{

typedef Point2DBase< double, MeasurementTag>    Measurement2DPoint;
typedef Point3DBase< double, MeasurementTag>    Measurement3DPoint;

/// Measurement points are two-dimensional by default.
typedef Measurement2DPoint                     MeasurementPoint;

} // namespace SIUTIL{.

#endif // MeasurementPoint_H

