#include "SiUtil.h"
#include "EVENT/LCParameters.h"


namespace SIUTIL{

void ShowRunHeaderParameters( string Comnt, EVENT::LCRunHeader* run ) {

  EVENT::LCParameters & pars = run->parameters() ;

  cout << endl  << endl  << Comnt << endl ;

  EVENT::StringVec svec1;  EVENT::StringVec skeys1 = pars.getStringKeys( svec1 ) ;

  cout << "     String parameters: skeys.size() = " << skeys1.size() << endl ;

  for( EVENT::StringVec::iterator ikey = skeys1.begin(); 
                                  ikey != skeys1.end() ; ikey++ ){

    EVENT::StringVec svec1;  
    EVENT::StringVec svec2 = pars.getStringVals(*ikey, svec1) ;

    cout<<"\t"<<" string key ="<< *ikey <<"  value = ";

    for( EVENT::StringVec::iterator jval = svec1.begin(); jval != svec1.end() ; jval++ )
         cout << *jval <<" " ;

    cout << endl;

  } // for.

  EVENT::StringVec fvec1; 
  EVENT::StringVec fkeys1 = pars.getFloatKeys(fvec1) ;
  cout << "     Float parameters: fkeys.size() = " << fkeys1.size() << endl ;

  for( EVENT::StringVec::iterator i = fkeys1.begin(); 
                                  i != fkeys1.end(); i++ )
     cout << "\t" << " fkeys = " << *i << " value = " << pars.getFloatVal(*i) << endl ;

  EVENT::StringVec ivec1; 
  EVENT::StringVec ikeys1 = pars.getIntKeys( ivec1 );

  cout << "     Int parameters: ikeys.size() = " << ikeys1.size() << endl ;
  for(EVENT::StringVec::iterator i = ikeys1.begin(); 
                                 i != ikeys1.end(); i++ ){
     EVENT::IntVec iv1 ;
     EVENT::IntVec iv = pars.getIntVals(*i, iv1) ; 
     for(EVENT::IntVec::iterator ii = iv.begin();ii != iv.end(); ii++ )
      cout<<"\t"<<" ikeys = "<< *i <<" value = "<< *ii << endl;
  }
} // ShowRunHeaderParameters( string, LCRunHeader* ) .

} // namespace SIUTIL.
